<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div :class="['card-role', { 'active' : selected }]">
        <div class="card-role-info">
            <div class="card-role-avatar">
                <!-- <img :src="all ? 'https://via.placeholder.com/50x50' : role && role?.img" :alt="all ? 'All' : role && role?.role_type"> -->
                <span>A</span>
            </div>
            <div class="card-role-type">{{ all ? 'All' : role  && role?.role_type}}</div>
        </div>
        <div class="card-role-actions" v-if="!all">
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(1)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">View</div>
            </label>
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(2)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">Edit</div>
            </label>
            <label class="form-group-checkbox">
                <input type="checkbox" :checked="hasPermission(3)"/>
                <div class="checkbox__checkmark"></div>
                <div class="checkbox__body">Share</div>
            </label>
        </div>
        <div class="card-role-bottom">
            <div class="card-role-totals">
                <div class="card-role-total">Users 
                    <span class="total">{{ totalUsersPermissions }}<span>/{{ totalUsers }}</span></span>
                </div>
            </div>
            <div class="card-role-button">
                <i class="icon-arrow-right"></i>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
    const props = defineProps({
        role: Object,
        userList: Object,
        selected: Boolean,
        all: Boolean,
        permissionSelectedId: Number
    });

    const hasPermission = (permissionId: number) => {
        return props.role && props.role.permissions.includes(permissionId);
    };

    const totalUsers = computed(() => {
        if(props.all){
            return props.userList?.length
        }
        else{
            if (!props.role || !props.userList) return 0;
            return props.userList.filter((user: any) => user.role === props.role?.id).length;
        }
        
    });

    const totalUsersPermissions = computed(() => {
        if(props.all){
            if(props.permissionSelectedId === 0){
                return props.userList?.filter((user: any) => [1, 2, 3].every(permissionId => user.permissions.includes(permissionId))).length;
            }else{
                return props.userList?.filter((user: any) => user.permissions.includes(props.permissionSelectedId)).length;
            }

        }else{
        if (!props.role || !props.userList) return 0;
    
        // Filter userList by role and permissions
        return props.userList.filter((user: any) => {
            return user.role === props.role?.id && 
                props.role?.permissions.every((permissionId: number) => user.permissions.includes(permissionId));
        }).length;
    }
    });
</script>